/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2019/10/15
* Description        : Main program body.
*******************************************************************************/
//ʱһжʱ㷽ʽ:
//T=(arr+1)*(psc+1)/Tpclk
//ʱһεʱΪ:
//t=(psc+1)/Tpclk

//(1/1M)Hz=1us  (1/1K)Hz=1ms

#include "debug.h"

void TIM1_UP_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

void GPIO_Toggle_INIT(void)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2|GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOD, &GPIO_InitStructure);
}

void TIM1_Int_Init(u16 arr,u16 psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};
    NVIC_InitTypeDef         NVIC_InitStructure={0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);       //ʹTIM1ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;                    //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler =psc;                  //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;    //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;//TIMģʽϼģʽ
    TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure);            //ָĲʼTIMxʱλ

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;         //TIM1ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;         //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure);                            //ʼNVIC

    TIM_ITConfig(TIM1,TIM_IT_Update,ENABLE ); //ʹTIM1жϣж

    TIM_Cmd(TIM1, ENABLE); //TIM1ʹ
}

void TIM2_Int_Init(u16 arr,u16 psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};
    NVIC_InitTypeDef         NVIC_InitStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);       //ʹTIM2ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;                    //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler =psc;                  //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;    //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;//TIMģʽϼģʽ
//  TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);            //ָĲʼTIMxʱλ

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;            //TIM2ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;         //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure);                            //ʼNVIC

    TIM_ITConfig(TIM2,TIM_IT_Update,ENABLE ); //ʹTIM2жϣж

    TIM_Cmd(TIM2, ENABLE); //TIM2ʹ
}

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{

    u8 i=0;

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    GPIO_Toggle_INIT();
    TIM1_Int_Init(100-1,720-1);
    TIM2_Int_Init(10-1,720-1);
    printf("SystemClk:%d\r\n",SystemCoreClock);

    while(1)
    {
        Delay_Ms(1000);
        GPIO_WriteBit(GPIOD, GPIO_Pin_0, (i == 0) ? (i = Bit_SET) : (i = Bit_RESET));
    }
}

void TIM1_UP_IRQHandler(void)
{
    static u8 i=0;

    if(TIM_GetITStatus(TIM1, TIM_IT_Update) != RESET) //TIM1жǷ
    {
        printf("111\r\n");
        TIM_ClearITPendingBit(TIM1,TIM_IT_Update);      //TIM1жϹλ
        GPIO_WriteBit(GPIOD, GPIO_Pin_2, (i == 0) ? (i = Bit_SET) : (i = Bit_RESET));
    }
}


void TIM2_IRQHandler(void)
{
    static u8 i=0;

    if(TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET) //TIM2жǷ
    {
        printf("222\r\n");
        TIM_ClearITPendingBit(TIM2,TIM_IT_Update);      //TIM2жϹλ
        GPIO_WriteBit(GPIOD, GPIO_Pin_3, (i==0) ? (i=Bit_SET):(i=Bit_RESET));
    }
}
